#ifndef DEMON_H
#define DEMON_H

#include "lattice.h"
#include "init.h"
#include "SU2.h"
#include "random.h"

class Demon{
public:
	Demon(int Nrep);
	void Init(Lattice &MyLat);
	vector<double> En(int Nupdates=0);
	void GetLat(Lattice &MyLat);
	
	~Demon();
private:
	void Init();
	void Clean();
	vector<double> Action(SU2& Umu, int LinCoord, int mu);
	SU2 RMatrix();
	vector<double> Ed;
	Lattice *Lat;
	SU2 (*DUfield)[Nd];
};
#endif
