#ifndef _PARAMETERS_H_
#define _PARAMETERS_H_
// ----- Parameter Container -----
#include "init.h"
class Params {
public:
	Params(const char *);
	
	void DecReinit();
	std::vector<double> Beta;
	double Betap;
	int Nrep;
	LatVec LatSize;
	enum State start;
	int getEquil() {return Equil;};
	int getEvol() {return Evol;};
	int getMeasSkip() {return MeasSkip;};
	int getOverRel() {return OverRel;};
	int getNrep() {return Nrep;};
	int getDemSweeps() {return DemonSweeps;};
	int getIseed() const {return Iseed;};
	int getDecimation() {return Decimation;};
	int getWloopLength() {return WloopLength;};
	double getDecSWc() const {return DecSWc;};
	
	int DoMeasure(enum Observables Obs) const {return ToMeasure.count(Obs);}
	const MeasObserv * AllMeasure() const {return &ToMeasure;}; 
private:
	MeasObserv ToMeasure;
	int Equil;
	int Evol;
	int MeasSkip;
	int OverRel;
	int DemonSweeps;
	int WloopLength;
	int Decimation;
	double DecSWc;
	int Iseed;
};
#endif //_PARAMETERS_H_
