#include "random.h"

#ifdef MARSAGLIA

Random::Random(int iseed1, int iseed2) 
{
	rmaset(iseed1,iseed2);
}

void Random::rmaset(int iseed1,int iseed2)
{
	int ii,jj,ij,kl,k,m,n;
	double s,t;
	ij=iseed1+1801;
	kl=9373+iseed2;
	mar_i=(ij/177)%177+2;
	mar_j=ij%177+2;
	k=(kl/169)%178+1;
	m=kl%169;
	for(ii=1;ii<=97;ii++) {
		s=0.0;
		t=0.5;
		for(jj=1;jj<=24;jj++) {
			n=(((mar_i*mar_j)%179)*k)%179;
			mar_i=mar_j;
			mar_j=k;
			k=n;
			m=(53*m+1)%169;
			if((m*n)%64>=32) s+=t;
			t=0.5*t;
		}
		mar_u[ii-1]=s;
	}
	mar_c =  362436.0/16777216.0;
	mar_cd= 7654321.0/16777216.0;
	mar_cm=16777213.0/16777216.0;
	mar_i=97;
	mar_j=33;
}

#endif
