#ifndef INIT_H
#define INIT_H

#include <iostream>
#include <cstdlib>
#include <vector>
#include <fstream>
#include <sstream>
#include <cassert>
#include <map>
#include <string>

using namespace std;

//#define NDEBUG

const int Nd=4; //4d


typedef double Vec4[4];
typedef int LatVec[Nd];

enum State {ORDERED, RANDOM, STARTFILE}; //start state

enum Observables {Plaq, Ploop, PloopCor, Wloop, WloopLarge, DemonEn};
typedef std::map<enum Observables, std::string, std::less<enum Observables> > MeasObserv;
typedef MeasObserv::value_type MOentry;


void outOfMemory(); //My handler of out of memory conditions
// ---------------------------------
#endif
