#include "jackknife.h"
template< class T >
JackKnife< T >::JackKnife(T array[], int N) {
	compute(array, N);
}
template< class T >
JackKnife< T >::JackKnife(vector<T> & vectin) {
	int N=vectin.size();
	T array[N];
	for (int i=0; i<N; i++) array[i]=vectin[i];
	compute(array, N);
}

template< class T >
JackKnife< T >::JackKnife(vector< vector<T> > & vectin) {
	int N=vectin.size();
	T array[N];
	int Ndata=vectin[0].size();
	for (int idat=0;idat<Ndata;idat++) {
		for (int i=0; i<N; i++) array[i]=(vectin[i])[idat];
		compute(array, N);
		Vmean.push_back(mean);
		Vvariance.push_back(variance);
		Verror.push_back(error);
	}
}
